package meerkat.voting.controller.callbacks;

import meerkat.voting.controller.commands.ControllerCommand;
import meerkat.voting.controller.commands.RestartVotingCommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.LinkedBlockingQueue;

public class ErrorMessageRestartCallback extends ControllerCallback<Integer> {
    protected final static Logger logger = LoggerFactory.getLogger(ErrorMessageRestartCallback.class);

    public ErrorMessageRestartCallback(int requestId,
                                       long ballotSerialNumber,
                                       LinkedBlockingQueue<ControllerCommand> controllerQueue) {
        super(requestId, ballotSerialNumber, controllerQueue);
    }

    @Override
    public void onSuccess(Integer result) {
        enqueueCommand(new RestartVotingCommand(getRequestIdentifier(), getBallotSerialNumber()));
    }

    @Override
    public void onFailure(Throwable t) {
        logger.error("Error message execution initiated a failure: " + t);
        enqueueCommand(new RestartVotingCommand(getRequestIdentifier(), getBallotSerialNumber()));
    }
}
